package com.jiuqi.util;

import java.util.List;
import java.util.StringTokenizer;
import java.util.ArrayList;

public class StringHelper
{
    public static final char SPACE = ' ';
    public static final String nullStr = "";
    public static final String comma = ",";
    public static final String semicolon = ";";
    public static final String leftParenthesis = "(";
    public static final String rightParenthesis = ")";
    public static final String interrogation = "?";
    public static final String space = " ";
    public static final String bias = "\\";
    public static final String breakstr = "\b";
    public static final String returnstr = "\u000b";
    public static final String select = "select ";
    public static final String from = " from ";
    public static final String where = " where ";
    public static final String set = " set ";
    public static final String and = " and ";
    public static final String or = " or ";
    public static final String not = " not ";
    public static final String equal = "=";
    public static final String insert = "insert into ";
    public static final String update = "update ";
    public static final String delete = "delete from ";
    public static final String create = "create table ";
    public static final String drop = "drop table ";
    public static final String alter = "alter table ";
    private static final String[] TRUE_VALUES;
    
    static {
        TRUE_VALUES = new String[] { "1", "T", "Y", "TRUE", "是", "对" };
    }
    
    private StringHelper() {
    }
    
    public static boolean isNull(final String value) {
        return value == null || value.equals("") || value.equalsIgnoreCase("null");
    }
    
    public static boolean isBoolean(final String value) {
        return value.equalsIgnoreCase("true") || value.equalsIgnoreCase("yes") || (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("1") || value.equalsIgnoreCase("01")) || (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("对") || value.indexOf("是") >= 0);
    }
    
    public static boolean parseBoolean(final String value) {
        for (int i = 0; i < StringHelper.TRUE_VALUES.length; ++i) {
            if (StringHelper.TRUE_VALUES[i].equalsIgnoreCase(value)) {
                return true;
            }
        }
        return false;
    }
    
    public static String getTrueValue(final String value) {
        if (value.equalsIgnoreCase("true") || value.equalsIgnoreCase("false")) {
            return "true";
        }
        if (value.equalsIgnoreCase("yes") || value.equalsIgnoreCase("no")) {
            return "yes";
        }
        if (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("F")) {
            return "T";
        }
        if (value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("N")) {
            return "Y";
        }
        if (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("否")) {
            return "是";
        }
        if (value.equalsIgnoreCase("1") || value.equalsIgnoreCase("0")) {
            return "1";
        }
        if (value.equalsIgnoreCase("01") || value.equalsIgnoreCase("00")) {
            return "01";
        }
        return "1";
    }
    
    public static String getFalseValue(final String value) {
        if (value.equalsIgnoreCase("true") || value.equalsIgnoreCase("false")) {
            return "false";
        }
        if (value.equalsIgnoreCase("yes") || value.equalsIgnoreCase("no")) {
            return "no";
        }
        if (value.equalsIgnoreCase("T") || value.equalsIgnoreCase("F")) {
            return "F";
        }
        if (value.equalsIgnoreCase("Y") || value.equalsIgnoreCase("N")) {
            return "N";
        }
        if (value.equalsIgnoreCase("是") || value.equalsIgnoreCase("否")) {
            return "否";
        }
        if (value.equalsIgnoreCase("1") || value.equalsIgnoreCase("0")) {
            return "0";
        }
        if (value.equalsIgnoreCase("01") || value.equalsIgnoreCase("00")) {
            return "00";
        }
        return "0";
    }
    
    public static boolean notNull(final String value) {
        return value != null && !value.equals("");
    }
    
    public static boolean readBool(final String str, final int index) {
        boolean result = false;
        if (str != null && str.length() > index && index >= 0) {
            result = (str.charAt(index) == '1');
        }
        return result;
    }
    
    public static String writeBool(final String str, final int index, final boolean value) {
        final StringBuffer result = (str == null) ? new StringBuffer() : new StringBuffer(str);
        if (index >= 0) {
            for (int nullcount = index - result.length(), i = 0; i <= nullcount; ++i) {
                result.append('#');
            }
            result.setCharAt(index, value ? '1' : '0');
        }
        return result.toString();
    }
    
    public static String readString(final String str, final int beginIndex, final int length) {
        final String result = null;
        int endIndex = beginIndex + length;
        if (str != null && str.length() > beginIndex && beginIndex >= 0 && endIndex > beginIndex) {
            endIndex = ((str.length() >= endIndex) ? endIndex : str.length());
            return str.substring(beginIndex, endIndex);
        }
        return result;
    }
    
    public static String writeString(final String str, final int beginIndex, final int length, final String value) {
        final StringBuffer result = (str == null) ? new StringBuffer() : new StringBuffer(str);
        if (beginIndex >= 0) {
            for (int nullcount = beginIndex + length - result.length(), i = 0; i < nullcount; ++i) {
                result.append(' ');
            }
            if (value != null) {
                for (int i = 0; i < length; ++i) {
                    final char chr = (i < value.length()) ? value.charAt(i) : ' ';
                    result.setCharAt(beginIndex + i, chr);
                }
            }
        }
        return result.toString();
    }
    
    public static String[] StringToStrArray(final String str, final String split) {
        String[] result = null;
        if (isNull(str)) {
            return result;
        }
        if (isNull(split)) {
            result = new String[] { str };
            return result;
        }
        final List list = new ArrayList();
        final StringTokenizer st = new StringTokenizer(str, split);
        while (st.hasMoreElements()) {
            list.add(st.nextElement());
        }
        if (list.size() > 0) {
            result = new String[list.size()];
            for (int i = 0; i < result.length; ++i) {
                result[i] = list.get(i);
            }
            return result;
        }
        result = new String[] { str };
        return result;
    }
    
    public static boolean equalStringArray(final String str1, final String str2) {
        boolean result = false;
        if (isNull(str1) && isNull(str2)) {
            return true;
        }
        final String[] list1 = StringToStrArray(str1);
        final String[] list2 = StringToStrArray(str2);
        if (list1 == null && list2 == null) {
            return str1.equals(str2);
        }
        if (list1 == null || list2 == null) {
            return str1.equals(str2);
        }
        if (list1.length != list2.length) {
            return false;
        }
        for (int i = 0; i < list1.length; ++i) {
            result = false;
            for (int k = 0; k < list2.length; ++k) {
                if (list1[i].equals(list2[k])) {
                    result = true;
                    list2[k] = "_$#@_*&^#%^";
                    break;
                }
            }
            if (!result) {
                break;
            }
        }
        return result;
    }
    
    public static String[] StringToStrArray(final String str, final char split) {
        String[] result = null;
        int p = 0;
        if (str == null || str.equals("")) {
            return null;
        }
        if (str.indexOf(split) < 0) {
            result = new String[] { str };
            return result;
        }
        final List list = new ArrayList();
        for (int i = 0; i < str.length(); ++i) {
            final char c = str.charAt(i);
            if (c == split) {
                if (i - p > 0) {
                    final String s = str.substring(p, i);
                    list.add(s);
                }
                else {
                    list.add("");
                }
                p = i + 1;
            }
        }
        if (p > 0 && p < str.length()) {
            final String s2 = str.substring(p, str.length());
            list.add(s2);
        }
        if (list.size() > 0) {
            result = new String[list.size()];
            for (int i = 0; i < list.size(); ++i) {
                result[i] = list.get(i);
            }
        }
        return result;
    }
    
    public static String[] StringToStrArray(final String str) {
        String[] result = null;
        int p = 0;
        if (str == null || str.equals("")) {
            return null;
        }
        if (str.indexOf(59) < 0 && str.indexOf(44) < 0) {
            result = new String[] { str };
            return result;
        }
        final List list = new ArrayList();
        for (int i = 0; i < str.length(); ++i) {
            final char c = str.charAt(i);
            if (c == ';' || c == ',') {
                if (i - p > 0) {
                    final String s = str.substring(p, i);
                    list.add(s);
                }
                else {
                    list.add("");
                }
                p = i + 1;
            }
        }
        if (p > 0 && p < str.length()) {
            final String s2 = str.substring(p, str.length());
            list.add(s2);
        }
        if (list.size() > 0) {
            result = new String[list.size()];
            for (int i = 0; i < list.size(); ++i) {
                result[i] = list.get(i);
            }
        }
        return result;
    }
    
    public static String stringOfChar(final char c, final int length) {
        final StringBuffer result = new StringBuffer(length);
        for (int i = 0; i < length; ++i) {
            result.append(c);
        }
        return result.toString();
    }
    
    public static String trimAll(final String str, final char c) {
        if (isNull(str)) {
            return null;
        }
        final StringBuffer result = new StringBuffer(str.length());
        for (int i = 0; i < str.length(); ++i) {
            if (str.charAt(i) != c) {
                result.append(str.charAt(i));
            }
        }
        return result.toString();
    }
    
    public static String trimAll(final String str) {
        return trimAll(str, ' ');
    }
    
    public static String trimL(final String str) {
        if (isNull(str)) {
            return null;
        }
        if (str.length() == 0 || str.charAt(0) != ' ') {
            return str;
        }
        int i;
        int pos;
        for (pos = (i = 1); i < str.length(); ++i) {
            if (str.charAt(i) != ' ') {
                pos = i;
                break;
            }
        }
        return str.substring(pos);
    }
    
    public static String trimR(final String str) {
        if (isNull(str)) {
            return null;
        }
        final int len = str.length();
        if (len == 0 || str.charAt(len - 1) != ' ') {
            return str;
        }
        int i;
        int pos;
        for (pos = (i = len - 2); i >= 0; --i) {
            if (str.charAt(i) != ' ') {
                pos = i;
                break;
            }
        }
        return str.substring(0, pos + 1);
    }
    
    public static String trimLR(final String str) {
        if (isNull(str)) {
            return null;
        }
        return str.trim();
    }
    
    public static boolean safeEquals(String str1, String str2) {
        str1 = (isNull(str1) ? "" : str1);
        str2 = (isNull(str2) ? "" : str2);
        return str1.equals(str2);
    }
    
    public static boolean safeEqualsIgnoreCase(String str1, String str2) {
        str1 = (isNull(str1) ? "" : str1);
        str2 = (isNull(str2) ? "" : str2);
        return str1.equalsIgnoreCase(str2);
    }
    
    public static int safeCompare(String str1, String str2) {
        str1 = (isNull(str1) ? "" : str1);
        str2 = (isNull(str2) ? "" : str2);
        return str1.compareTo(str2);
    }
    
    public static int safeCompareIgnoreCase(String str1, String str2) {
        str1 = (isNull(str1) ? "" : str1);
        str2 = (isNull(str2) ? "" : str2);
        return str1.compareToIgnoreCase(str2);
    }
    
    public static int safeIndexOf(String str, String subStr) {
        str = (isNull(str) ? "" : str);
        subStr = (isNull(subStr) ? "" : subStr);
        return str.indexOf(subStr);
    }
    
    public static int safeIndexOfIgnoreCase(String str, String subStr) {
        str = (isNull(str) ? "" : str.toLowerCase());
        subStr = (isNull(subStr) ? "" : subStr.toLowerCase());
        return str.indexOf(subStr);
    }
}
